import java.io.BufferedWriter;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.util.Random;

public class BuecherXmlErzeuger
{
   static final String TEXT_XML_START_VEN =
      "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n" +
      "<mns:buecher xmlns:mns=\"http://meinnamespace.meinefirma.de\"\n" +
      "             xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n" +
      "             xsi:schemaLocation=\"http://meinnamespace.meinefirma.de Buecher.xsd\">\n";
   static final String TEXT_XML_START_SAL =
      "<?xml version=\"1.0\" encoding=\"ISO-8859-1\"?>\n" +
      "<buecher xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n" +
      "         xsi:schemaLocation=\"http://meinnamespace.meinefirma.de BuecherSalami.xsd\"\n" +
      "         xmlns:mns=\"http://meinnamespace.meinefirma.de\"\n" +
      "         xmlns=\"http://meinnamespace.meinefirma.de\">\n";
   static final String TEXT_A_1 =
      "  <autor ";
   static final String TEXT_A_2 = "id=\"";
   static final String TEXT_A_3 = "\">\n" +
      "    <name>Hinz ";
   static final String TEXT_A_4 = "</name>\n" +
      "    <ort>Hamburg</ort>\n" +
      "  </autor>\n";
   static final String TEXT_V_1 =
      "  <verlag ";
   static final String TEXT_V_2 = "id=\"";
   static final String TEXT_V_3 = "\">\n" +
      "    <name>Aachener Java-Verlag ";
   static final String TEXT_V_4 = "</name>\n" +
      "    <ort>Aachen</ort>\n" +
      "  </verlag>\n";
   static final String TEXT_B_1 =
      "  <buch ";
   static final String TEXT_B_2 = "autorID=\"";
   static final String TEXT_B_3 = "\" ";
   static final String TEXT_B_4 = "verlagID=\"";
   static final String TEXT_B_5 = "\">\n" +
      "    <titel>XML mit Java ";
   static final String TEXT_B_6 = "</titel>\n" +
      "  </buch>\n";
   static final String TEXT_XML_ENDE_VEN =
      "</mns:buecher>";
   static final String TEXT_XML_ENDE_SAL =
      "</buecher>";

   public static void main( String[] args ) throws IOException
   {
      if( args.length < 2 ) {
         System.out.println( "Bitte Buecher-XML-Dokument und Anzahl der Buecher angeben, z.B.:\n" +
                             "java de.meinefirma.main.BuecherXmlErzeuger Buecher1000.xml 1000" );
         return;
      }
      boolean salami = (args.length == 3 && args[2].toLowerCase().startsWith( "s" ));
      erzeugeXmlDatei( args[0], Integer.parseInt( args[1] ), salami );
   }

   public static void erzeugeXmlDatei( String xmlDatei, int anzahlElemente, boolean salami ) throws IOException
   {
      int            nav = Math.min( anzahlElemente / 3, 100 );
      int            nb  = anzahlElemente - 2 * nav;
      StringBuffer   sb  = new StringBuffer();
      BufferedWriter out = new BufferedWriter( new OutputStreamWriter( new FileOutputStream( xmlDatei ) ) );
      String         mns = ( salami ) ? "mns:" : "";
      String         text_a_12 = TEXT_A_1 + mns + TEXT_A_2;
      String         text_v_12 = TEXT_V_1 + mns + TEXT_V_2;
      String         text_b_12 = TEXT_B_1 + mns + TEXT_B_2;
      String         text_b_34 = TEXT_B_3 + mns + TEXT_B_4;
      try {
         out.write( ( salami ) ? TEXT_XML_START_SAL : TEXT_XML_START_VEN );
         for( int i = 0; i < nav; i++ ) {
            sb.append( text_a_12 ).append( i ).append( TEXT_A_3 ).append( (new Random()).nextInt() ).append( TEXT_A_4 );
         }
         out.write( sb.toString() );
         sb = new StringBuffer();
         for( int i = 0; i < nav; i++ ) {
            sb.append( text_v_12 ).append( i ).append( TEXT_V_3 ).append( (new Random()).nextInt() ).append( TEXT_V_4 );
         }
         out.write( sb.toString() );
         sb = new StringBuffer();
         for( int i = 0; i < nb; i++ ) {
            sb = new StringBuffer();
            sb.append( text_b_12 ).append( (new Random()).nextInt( nav ) ).append( text_b_34 )
                                  .append( (new Random()).nextInt( nav ) ).append( TEXT_B_5 ).append( (new Random()).nextInt() ).append( TEXT_B_6 );
            out.write( sb.toString() );
         }
         out.write( ( salami ) ? TEXT_XML_ENDE_SAL : TEXT_XML_ENDE_VEN );
         out.newLine();
      } finally {
         out.close();
      }
      System.out.println( "'" + xmlDatei + "' angelegt mit " + nav + " Autoren, "
                                                             + nav + " Verlagen und " + nb + " Buechern." );
   }
}
