import java.io.*;
import java.text.*;
import java.util.Date;

public class Zeitdifferenz
{
   public static void main( String[] args ) throws IOException, ParseException
   {
      final String           fn = "Zeitdifferenz-Startzeit.txt";
      final SimpleDateFormat df = new SimpleDateFormat( "yyyy-MM-dd HH:mm:ss.SSS" );
      String                 zeitAktuell = df.format( new Date() );
      String                 zeitZuletzt = null;

      if( args.length > 0 && args[0].toLowerCase().equals( "start" ) ) {
         File f = new File( fn );
         if( f.exists() ) { f.delete(); }
      } else {
         try {
            BufferedReader in = new BufferedReader( new InputStreamReader( new FileInputStream( fn ) ) );
            try { zeitZuletzt = in.readLine(); } finally { in.close(); }
         } catch( FileNotFoundException ex ) { /* ok */ }
      }

      System.out.println( "\nZeitmessung:" );
      if( zeitZuletzt == null ) {
         System.out.println( "Start-Zeit:    " + zeitAktuell );
      } else {
         System.out.println( "Start-Zeit:    " + zeitZuletzt );
         System.out.println( "Aktuelle Zeit: " + zeitAktuell );
         System.out.println( "Dauer:         " + ermittleDauer( df.parse( zeitZuletzt ), df.parse( zeitAktuell ) ) + "\n" );
      }

      BufferedWriter out = new BufferedWriter( new OutputStreamWriter( new FileOutputStream( fn ) ) );
      try { out.write( zeitAktuell ); out.newLine(); } finally { out.close(); }
   }

   static String ermittleDauer( Date startZeit, Date endeZeit )
   {
      long dauerMs = endeZeit.getTime() - startZeit.getTime();
      if( dauerMs < 1000 ) return "" + dauerMs + " ms";
      return (new DecimalFormat( "#,##0.00" )).format( dauerMs / 1000. ) + " s";
   }
}
