package de.meinefirma.meinprojekt.crypto;

import java.io.IOException;
import java.security.NoSuchAlgorithmException;
import java.util.Locale;

public class OpenPgpBouncyCastleStreamUtilMain
{
   public static void main( String[] args ) throws NoSuchAlgorithmException, IOException
   {
      OpenPgpBouncyCastleStreamUtil.addBouncyCastleProvider();

      if( args.length == 5 && args[0].toLowerCase( Locale.GERMAN ).startsWith( "-g" ) ) { // generateKeyPair
         OpenPgpBouncyCastleStreamUtil.generateKeyPairFiles( args[1], args[2], args[3], args[4], true );
         return;
      }
      if( args.length == 4 && args[0].toLowerCase( Locale.GERMAN ).startsWith( "-e" ) ) { // encrypt
         OpenPgpBouncyCastleStreamUtil.encryptFile( args[1], args[2], args[3], false, true );
         return;
      }
      if( args.length == 5 && args[0].toLowerCase( Locale.GERMAN ).startsWith( "-d" ) ) { // decrypt
         OpenPgpBouncyCastleStreamUtil.decryptFile( args[1], args[2], args[3], args[4] );
         return;
      }

      System.out.println( "\nFehler: Es werden vier bzw. fuenf Parameter benoetigt:\n" +
            "Zum Generieren des privaten und oeffentlichen RSA-Schluessels:\n" +
            "  -g PrivateKeyFile PublicKeyFile KeyIdName Passphrase\n" +
            "Zum Verschluesseln:\n" +
            "  -e EncryptedFile InputFile PublicKeyFile\n" +
            "Zum Entschluesseln:\n" +
            "  -d OutputFile EncryptedFile PrivateKeyFile Passphrase\n" );
   }
}
