package de.meinefirma.meinprojekt.crypto;

import java.io.*;
import java.security.GeneralSecurityException;
import java.util.*;
import org.junit.*;

public class CryptoRsaAesTest
{
   @Test
   public void testCryptoRsaAes() throws GeneralSecurityException, ClassNotFoundException, IOException
   {
      String privateKeyFile = "target/PrivateKey.rsa";
      String publicKeyFile  = "target/PublicKey.rsa";
      String srcFile        = "target/MeineSrcDatei.txt";
      String encFile        = "target/MeineVerschluesselteDatei.aes.rsa";
      String dstFile        = "target/MeineDstDatei.txt";
      String text           = "Blablupp \u00E4\u00F6\u00FC\u00DF\u20AC"; // Umlaute und Eurozeichen
      String charEnc        = "UTF-8";

      BufferedWriter out = new BufferedWriter( new OutputStreamWriter( new FileOutputStream( srcFile ), charEnc ) );
      try { out.write( text ); } finally { out.close(); }

      CryptoRsaAes.generateKeyPair( privateKeyFile, publicKeyFile, 2048 );
      Assert.assertTrue( new File( privateKeyFile ).exists() );
      Assert.assertTrue( new File( publicKeyFile  ).exists() );

      CryptoRsaAes.encrypt( publicKeyFile, srcFile, encFile );
      Assert.assertTrue( new File( encFile ).exists() );

      CryptoRsaAes.decrypt( privateKeyFile, encFile, dstFile );
      Assert.assertTrue( new File( dstFile ).exists() );

      List<String>   ss = new ArrayList<String>();
      BufferedReader in = new BufferedReader( new InputStreamReader( new FileInputStream( dstFile ), charEnc ) );
      try {
         String line;
         while( (line = in.readLine()) != null ) {
            ss.add( line );
         }
      } finally {
         in.close();
      }
      Assert.assertEquals( 1, ss.size() );
      Assert.assertEquals( text, ss.get( 0 ) );
   }
}
