package de.meinefirma.meinprojekt.crypto;

import java.io.*;
import java.util.*;
import java.util.zip.DataFormatException;
import org.junit.*;

public class CryptoWinZipAESTest
{
   @Test
   public void testWinZipAES() throws IOException, DataFormatException
   {
      String srcFile  = "target/MeineDatei.txt";
      String zipFile  = "target/MeineVerschluesselteZipDatei.zip";
      String dstDir   = "target/testergebnis";
      String dstFile  = dstDir + File.separator + srcFile;
      String password = "geheim";
      String text     = "Blablupp \u00E4\u00F6\u00FC\u00DF\u20AC"; // Umlaute und Eurozeichen
      String charEnc  = "UTF-8";

      BufferedWriter out = new BufferedWriter( new OutputStreamWriter( new FileOutputStream( srcFile ), charEnc ) );
      try { out.write( text ); } finally { out.close(); }

      CryptoWinZipAES.zipAndEncrypt( srcFile, zipFile, password );
      Assert.assertTrue( new File( zipFile ).exists() );

      CryptoWinZipAES.unzipAndDecrypt( zipFile, dstDir, password );
      Assert.assertTrue( new File( dstFile ).exists() );

      List<String>   ss = new ArrayList<String>();
      BufferedReader in = new BufferedReader( new InputStreamReader( new FileInputStream( dstFile ), charEnc ) );
      try {
         String line;
         while( (line = in.readLine()) != null ) {
            ss.add( line );
         }
      } finally {
         in.close();
      }
      Assert.assertEquals( 1, ss.size() );
      Assert.assertEquals( text, ss.get( 0 ) );
   }
}
